"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createAction;
/**
 * Created by leiyouwho on 6/29/16.
 */

function createAction(type) {
  var actionHandler = function actionHandler() {
    var hasError = (arguments.length <= 0 ? undefined : arguments[0]) instanceof Error;

    var action = {
      type: type
    };

    var payload = hasError ? arguments.length <= 0 ? undefined : arguments[0] : function (t) {
      return t;
    }.apply(undefined, arguments);

    if (!(payload === null || payload === undefined)) {
      action.payload = payload;
    }

    if (hasError) {
      action.error = true;
    }
    return action;
  };
  actionHandler.toString = function () {
    return type;
  };

  return actionHandler;
}
module.exports = exports["default"];