'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Global = require('./Global');

var GlobalRedux = _interopRequireWildcard(_Global);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by leiyouwho on 6/22/16.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


function _getValue(reducerPath) {
  var storeState = GlobalRedux.getStore();
  reducerPath.split('/').map(function (key) {
    if (storeState === undefined) {
      return;
    }
    if (storeState instanceof _immutable2.default.Map || storeState instanceof _immutable2.default.List) {
      storeState = storeState.get(key);
    } else {
      storeState = storeState[key];
    }
  });
  return storeState;
}

function _bindReducer(reducerPath) {
  var storeState = GlobalRedux.getStore();
  reducerPath.split('/').map(function (key) {
    if (storeState === undefined) {
      return;
    }
    if (storeState instanceof _immutable2.default.Map || storeState instanceof _immutable2.default.List) {
      storeState = storeState.get(key);
    } else {
      storeState = storeState[key];
    }
  });
  return {
    value: _getValue(reducerPath),
    onChange: function onChange(e) {
      var value = void 0;
      try {
        value = e.target.value;
      } catch (error) {
        value = e;
      }
      GlobalRedux.getDispatch()({
        type: '@@CHANGE/' + reducerPath,
        data: value
      });
    }
  };
}

function _changeAction(reducerPath, value) {
  GlobalRedux.getDispatch()({
    type: '@@CHANGE/' + reducerPath,
    data: value
  });
}

/**
 * Delete Store value of reducrPath
 * @param reducerPath
 * @private
 */
function _deleteAction(reducerPath) {
  GlobalRedux.getDispatch()({
    type: '@@DELETE/' + reducerPath
  });
}

/**
 * Push Value to Array of subReducer
 * @param reducerPath
 * @param value
 * @private
 */
function _pushAction(reducerPath, data) {
  GlobalRedux.getDispatch()({
    type: '@@PUSH/' + reducerPath,
    data: data
  });
}

exports.default = function (Component) {
  return function (_React$Component) {
    _inherits(ConnectStore, _React$Component);

    function ConnectStore() {
      _classCallCheck(this, ConnectStore);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(ConnectStore).apply(this, arguments));
    }

    _createClass(ConnectStore, [{
      key: 'render',
      value: function render() {
        return _react2.default.createElement(Component, _extends({}, this.props, {
          bindReducer: _bindReducer,
          getValue: _getValue,
          deleteAction: _deleteAction,
          pushAction: _pushAction,
          changeAction: _changeAction
        }));
      }
    }]);

    return ConnectStore;
  }(_react2.default.Component);
};

// mapState 导入 Store数据

// inject dispatch

// inject bindReducer
// (reducerPath) => {value, onChange}


module.exports = exports['default'];