/**
 * 使用canvas压缩图片
 * @param data 图片base64之后的字符串
 * @param type 图片类型
 * @param quality 图片质量
 * @returns {string}  压缩后的图片数据
 */

function comprass(data, type, quality) {
  if (type !== 'jpg' || type !== 'png') {
    return data;
  }
  var mime_type = "image/jpeg";
  if (type === "png") mime_type = "image/png";
  var canvas = document.createElement('canvas');
  
  //naturalWidth真实图片的宽度
  canvas.width = data.naturalWidth;
  canvas.height = data.naturalHeight;
  var compressData = canvas.toDataURL(mime_type, quality);
  return compressData;
}

export default comprass;