/**
 * Created by leiyouwho on 6/22/16.
 */
import React from 'react';
import * as GlobalRedux from './Global';
import Immutable from 'immutable';

function _getValue(reducerPath) {
  let storeState = GlobalRedux.getStore();
  reducerPath.split('/').map(key => {
    if (storeState === undefined) {
      return;
    }
    if (storeState instanceof Immutable.Map || storeState instanceof Immutable.List) {
      storeState = storeState.get(key);
    } else {
      storeState = storeState[key];
    }
  });
  return storeState;
}

function _bindReducer(reducerPath) {
  let storeState = GlobalRedux.getStore();
  reducerPath.split('/').map(key => {
    if (storeState === undefined) {
      return;
    }
    if (storeState instanceof Immutable.Map || storeState instanceof Immutable.List) {
      storeState = storeState.get(key);
    } else {
      storeState = storeState[key];
    }
  });
  return {
    value: _getValue(reducerPath),
    onChange: (e) => {
      let value;
      try {
        value = e.target.value;
      } catch(error) {
        value = e;
      }
      GlobalRedux.getDispatch()({
        type: '@@CHANGE/' + reducerPath,
        data: value,
      });
    },
  };
}

function _changeAction(reducerPath, value) {
  GlobalRedux.getDispatch()({
    type: '@@CHANGE/' + reducerPath,
    data: value,
  });
}

/**
 * Delete Store value of reducrPath
 * @param reducerPath
 * @private
 */
function _deleteAction(reducerPath) {
  GlobalRedux.getDispatch()({
    type: '@@DELETE/' + reducerPath,
  });
}

/**
 * Push Value to Array of subReducer
 * @param reducerPath
 * @param value
 * @private
 */
function _pushAction(reducerPath, data) {
  GlobalRedux.getDispatch()({
    type: '@@PUSH/' + reducerPath,
    data,
  });
}


export default (Component) => {
  return class ConnectStore extends React.Component {
    render() {
      return (
        <Component { ...this.props }
          bindReducer={_bindReducer}
          getValue={_getValue}
          deleteAction={_deleteAction}
          pushAction={_pushAction}
          changeAction={_changeAction}
        />
      );
    }
  };
};


// mapState 导入 Store数据

// inject dispatch

// inject bindReducer
// (reducerPath) => {value, onChange}
